'by julionib

'keep the violence in games :)
'be cool

Imports System ' basic imports
Imports GTA ' basic imports
Imports System.Windows.Forms ' needed to have access to "keys" enumeration, for example
Imports System.Drawing ' needed to handle colors referencing the color name, ex: myCar.color = System.Drawing.Color.Black
Imports System.Collections.Generic
imports system.io

Public Class AC130
    Inherits Script
		
	private bInAC130, bNightVisionOn as boolean
	private Rocket as gta.object	
	private plane as gta.object
	private planeHeading as double = 0
	private timeScript as int16 = 0
	private RocketExpTimeout as int16 = 0
	private RocketDelay as int16 = 150
	private vecOriginalPos as vector3
	private rocketEffect as int32 = 0
	private rocketRotation as vector3
	private camDelay as int16 = 0
	private lightList as new list(of lights)
	private lightTmp as lights = nothing
	private bCancelLights as boolean = false	
	private noiseEffectCounter as int16 = 0
	private timeShoot20mm as int16 = 0
	private timeShoot40mm as int16 = 0
	private bDraw20mmTrace as boolean = false
	private dot40mmList as new list(of dot40mm)
	private camMode as int16 = 0
	private currWeapon as int16 = 0	
	private camDir, camDirOrig as vector3
	private dot40mmBullet as int16 = 0
	private dot20mmTimeScarePeds as double = 0
	private bNoiseFX, bCrosshair as boolean	
	private playerPosAux as vector3	
	private trainList as new list(of trains)
	private	trainItem as trains
	private timeNVFindObj, timeNVGlowObj, timeNVFindObjCount, timeNVGlowObjCount as double
	private shakeCam as double = 0
	private shakeCamAmount as double = 0
	private camDEDir as vector3
	private planeSpeedMultiplier as double = 1
	private camHeight, camHeightAux as double
	private bErroDraw as boolean = false
	private maxDistFindTargets as double
	private loadDelay as int16 = 500
	private bDisableTextures as boolean
	private camFOV as double = 50
	
	private sVersion as string = "1.0"
	
	'cameras section
	private camAC130, camRocket, camDEAim as camera
	
	'hotkeys section
	private hkActivate1, hkActivate2, hkShoot, hkChangeGun, hkNightvision, hkCameraMode, hkSwTo105mm, hkSwTo40mm, hkSwTo20mm, _
		hkSpeedUp, hkSpeedDown as keys
	
	'sprites section
	private texCr20, texCr40, texCr105, textN1, textN2, textN3, textN4, text20mmTrace, textDEAim as texture
	
	'"deadEye" section
	private bDeadEye as boolean = false
	private findTargetTime as double
	private DETarget as targetFound
	private DEShoots as int16 = 0
	private camDEAimFOV as int16 = 50
	
	Public Sub New()
		Me.interval = 10
    End Sub

	private sub loadAux		
		Game.Console.Print("AC130 Script Mod by JulioNIB v" & sVersion)
		Game.Console.Print("Sprites, sounds and idea by TheVideoVolcano")
		
		camAC130 = new camera
		camRocket = new camera
		camDEAim = new camera
		
		if exists(camAC130) then camAC130.fov = game.currentcamera.fov
		if exists(camRocket) then camRocket.fov = game.currentcamera.fov		
		if exists(camDEAim) then camDEAim.fov = game.currentcamera.fov
		
		timeNVFindObjCount = 0
		timeNVGlowObjCount = 0
		
		bInAC130 = false
		bNightVisionOn = false
		
		findTargetTime = 0
		
		DETarget = new targetFound
		
		camHeight = 0
		camHeightAux = 0
		
		If Settings.GetValueKey("bNoiseFX", "General", -1) = -1 Then Settings.SetValue("bNoiseFX", "General", 1)
		If Settings.GetValueKey("bCrosshair", "General", -1) = -1 Then Settings.SetValue("bCrosshair", "General", 1)
		If Settings.GetValueKey("maxDistFindTargets", "General", -1) = -1 Then Settings.SetValue("maxDistFindTargets", "General", 200)
		If Settings.GetValueKey("bDisableTextures", "General", -1) = -1 Then 
			if game.CurrentEpisode = GameEpisode.GTAIV then
				Settings.SetValue("bDisableTextures", "General", 0)
			else
				Settings.SetValue("bDisableTextures", "General", 1)
			end if
		end if
		If Settings.GetValueKey("timeNVFindObj", "NightVision", -1) = -1 Then Settings.SetValue("timeNVFindObj", "NightVision", 500)
		If Settings.GetValueKey("timeNVGlowObj", "NightVision", -1) = -1 Then Settings.SetValue("timeNVGlowObj", "NightVision", 20)
		
		If Settings.GetValueKey("hkActivate1", "HotKeys", -1) = -1 Then Settings.SetValue("hkActivate1", "HotKeys", keys.f7)
		If Settings.GetValueKey("hkActivate2", "HotKeys", -1) = -1 Then Settings.SetValue("hkActivate2", "HotKeys", keys.f8)
		If Settings.GetValueKey("hkShoot", "HotKeys", -1) = -1 Then Settings.SetValue("hkShoot", "HotKeys", keys.lbutton)
		If Settings.GetValueKey("hkChangeGun", "HotKeys", -1) = -1 Then Settings.SetValue("hkChangeGun", "HotKeys", keys.rbutton)
		If Settings.GetValueKey("hkNightvision", "HotKeys", -1) = -1 Then Settings.SetValue("hkNightvision", "HotKeys", keys.n)
		If Settings.GetValueKey("hkCameraMode", "HotKeys", -1) = -1 Then Settings.SetValue("hkCameraMode", "HotKeys", keys.c)
		If Settings.GetValueKey("hkSwTo105mm", "HotKeys", -1) = -1 Then Settings.SetValue("hkSwTo105mm", "HotKeys", keys.d1)
		If Settings.GetValueKey("hkSwTo40mm", "HotKeys", -1) = -1 Then Settings.SetValue("hkSwTo40mm", "HotKeys", keys.d2)
		If Settings.GetValueKey("hkSwTo20mm", "HotKeys", -1) = -1 Then Settings.SetValue("hkSwTo20mm", "HotKeys", keys.d3)
		If Settings.GetValueKey("hkSpeedUp", "HotKeys", -1) = -1 Then Settings.SetValue("hkSpeedUp", "HotKeys", keys.w)
		If Settings.GetValueKey("hkSpeedDown", "HotKeys", -1) = -1 Then Settings.SetValue("hkSpeedDown", "HotKeys", keys.s)
		
		Settings.save
		
		bNoiseFX = Settings.GetValueKey("bNoiseFX", "General", 1) = 1
		bCrosshair = Settings.GetValueKey("bCrosshair", "General", 1) = 1
		maxDistFindTargets = Settings.GetValueKey("maxDistFindTargets", "General", 200)
		bDisableTextures = Settings.GetValueKey("bDisableTextures", "General", 0) = 1
		
		timeNVFindObj = Settings.GetValueKey("timeNVFindObj", "NightVision", 500)
		timeNVGlowObj = Settings.GetValueKey("timeNVGlowObj", "NightVision", 20)
		
		hkActivate1 = Settings.GetValueKey("hkActivate1", "HotKeys", keys.f7)
		hkActivate2 = Settings.GetValueKey("hkActivate2", "HotKeys", keys.f8)
		hkShoot = Settings.GetValueKey("hkShoot", "HotKeys", keys.lbutton)
		hkChangeGun = Settings.GetValueKey("hkChangeGun", "HotKeys", keys.rbutton)
		hkNightvision = Settings.GetValueKey("hkNightvision", "HotKeys", keys.n)
		hkCameraMode = Settings.GetValueKey("hkCameraMode", "HotKeys", keys.c)
		hkSwTo105mm = Settings.GetValueKey("hkSwTo105mm", "HotKeys", keys.d1)
		hkSwTo40mm = Settings.GetValueKey("hkSwTo40mm", "HotKeys", keys.d2)
		hkSwTo20mm = Settings.GetValueKey("hkSwTo20mm", "HotKeys", keys.d3)
		hkSpeedUp = Settings.GetValueKey("hkSpeedUp", "HotKeys", keys.w)
		hkSpeedDown = Settings.GetValueKey("hkSpeedDown", "HotKeys", keys.s)
		
		try
			texCr20 = new texture(file.readallbytes(".\Scripts\AC130Files\cr20mm.png"))
			texCr40 = new texture(file.readallbytes(".\Scripts\AC130Files\cr40mm.png"))
			texCr105 = new texture(file.readallbytes(".\Scripts\AC130Files\cr105mm.png"))
			text20mmTrace = new texture(file.readallbytes(".\Scripts\AC130Files\20mmTrace.png"))
			textDEAim = new texture(file.readallbytes(".\Scripts\AC130Files\DeadEyeAim.png"))
			textN1 = new texture(file.readallbytes(".\Scripts\AC130Files\N1.png"))
			textN2 = new texture(file.readallbytes(".\Scripts\AC130Files\N2.png"))
			textN3 = new texture(file.readallbytes(".\Scripts\AC130Files\N3.png"))
			textN4 = new texture(file.readallbytes(".\Scripts\AC130Files\N4.png"))			
		catch			
		end try
		
		try
			Rocket = world.createobject("cj_rpg_rocket", vecOriginalPos + vector3.worldup * 300)			
			plane = world.createobject("cj_plane_1", vecOriginalPos + vector3.worldup * 305)
			
			if exists(Rocket) then 
				Rocket.visible = false
				native.function.call("SET_OBJECT_COLLISION", Rocket, false)
			end if
			if exists(plane) then
				plane.visible = false
				native.function.call("SET_OBJECT_COLLISION", plane, false)
			end if
			
			for each bul as dot40mm in dot40mmList
				if exists(bul.bullet) then bul.bullet.delete
			next
		
			dot40mmList.clear
			
			dim tmp40mm as dot40mm
	
			for c as int16 = 1 to 10
				tmp40mm = new dot40mm(vecOriginalPos + vector3.worldup * 30, plane)
				
				wait(10)
				
				if exists(tmp40mm.bullet) then
					native.function.call("SET_OBJECT_COLLISION", tmp40mm.bullet, false)
					dot40mmList.add(tmp40mm)
				end if
			next
		catch
		end try
	end sub
	
	private class lights
		public veh as vehicle
		public light, light2, light3 as light
		public anPed as ped
		public bVeh as boolean
		public vehH as double
		public l1pos, l2pos, l3pos  as double
		
		public sub new
			veh = nothing
			anPed = nothing
			bVeh = true
			vehH = 0
			l1pos = 0
			l2pos = 0
			l3pos = 0
		end sub
	end class
	
	private class dot40mm
		public bullet as gta.object
		public launched as boolean = false
		public dir as vector3
		public timeOut
		
		public sub new(pos as vector3, attachTo as gta.object)
			bullet = world.createobject("w_grenade", pos)
				
			native.function.call("ATTACH_OBJECT_TO_OBJECT", bullet, attachTo, false, 0, 0, 0, 0, 0, 0)
			
			timeOut = 0
		end sub
	end class
	
	private class trains
		public pos, rot, vel as vector3
		public m as model
		public train as gta.object
		public bCreate as boolean = true
		public speed as double
		
		public sub new(v as gta.vehicle)
			pos = v.position
			rot = v.rotation
			speed = v.speed
			m = v.model
			train = nothing
		end sub
	end class
	
	private class targetFound
		public p as ped = nothing
		public v as vehicle = nothing
		public vec as vector3 = vector3.zero
		public bPed as boolean = false
		public bVeh as boolean = false
		public valid as boolean = false
		public cpTarget as checkpoint = new checkpoint
		
		public sub reset
			bPed = false
			bVeh = false
			p = nothing
			v = nothing
			valid = false
		end sub
		
		public sub new
			cpTarget.color = system.drawing.color.fromargb(75, 255, 0, 0)
			cpTarget.diameter = 2.0
			cpTarget.visible = false
		end sub
	end class
	
	private sub DETargetUpdateVec
		if DETarget.bPed then
			if exists(DETarget.p) then
				DETarget.vec = DETarget.p.position
			else
				DETarget.p = nothing
				DETarget.bPed = false
				DETarget.valid = false
			end if
		elseif DETarget.bVeh then
			if exists(DETarget.v) then
				DETarget.vec = DETarget.v.position
			else
				DETarget.v = nothing
				DETarget.bVeh = false
				DETarget.valid = false
			end if
		end if
	end sub
	
	private sub msg(sMsg as string, time as int32)
		Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", sMsg, time, 1)
	end sub
	
    Private Sub keyDown(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyDown		
		if ((e.key = hkActivate1) orelse (e.key = hkActivate2)) andalso (not exists(rocket) orelse (exists(rocket) andalso not rocket.metadata.launched)) then			
			if not bInAC130 then				
				msg("Calling AC130...", 2000)
				
				bDeadEye = (e.key = hkActivate2)
				
				currWeapon = 0
				camMode = 0
				
				vecOriginalPos = player.character.position
				playerPosAux = vecOriginalPos
				
				try
					if not exists(Rocket) then Rocket = world.createobject("cj_rpg_rocket", vecOriginalPos + vector3.worldup * 300)			
					if not exists(plane) then plane = world.createobject("cj_plane_1", vecOriginalPos + vector3.worldup * 305)
					
					native.function.call("SET_OBJECT_COLLISION", Rocket, true)
					native.function.call("SET_OBJECT_COLLISION", plane, true)
					Rocket.visible = true
					plane.visible = true
					
					for each bul as dot40mm in dot40mmList
						if exists(bul.bullet) then bul.bullet.delete
					next
				
					dot40mmList.clear
					
					dim tmp40mm as dot40mm
			
					for c as int16 = 1 to 10
						tmp40mm = new dot40mm(vecOriginalPos + vector3.worldup * 30, plane)
						
						wait(10)
						
						dot40mmList.add(tmp40mm)
					next
				catch
					msg("Error creating objects, try again...", 2000)
					
					if exists(plane) then plane.delete
					if exists(rocket) then rocket.delete
					
					exit sub
				end try
				
				native.function.call("ATTACH_OBJECT_TO_OBJECT", rocket, plane, false, 0, 0, 0, 0, 0, 0)
				
				planeHeading = 15
				plane.heading = planeHeading
				
				if not bDeadEye then 
					plane.position = vecOriginalPos + player.character.direction * -200 + vector3.worldup * 250
					plane.visible = false
				else
					plane.position = vecOriginalPos + player.character.direction * 20 + vector3.worldup * 250
					plane.visible = true
				end if
				
				CamAC130.position = plane.position
				camDir = plane.direction
				camDir.z = -2
				camDirOrig = camDir
				CamAC130.direction = rotatevec(camDir, 60)
				
				rocket.visible = false
				
				if not bDeadEye then
					game.FadeScreenOut(1000, true)
					
					player.character.visible = false
					'native.function.call("ATTACH_PED_TO_OBJECT", player.character, plane, false, 0, 0, 0, 0, 0, false, false)
					'native.function.call("ATTACH_PED_TO_OBJECT", player.character, rocket, false, 0, 0, 0, 0, 0, false, false)
					'native.function.call("ATTACH_PED_TO_OBJECT", player.character, plane, false, 0, 0, -230.0, 0, 0, false, false)
					
					player.character.makeproofto(true, true, true, true, true)
					native.function.call("SET_CHAR_COLLISION", player.character, false)
					
					'player.character.attachblip
					'plane.attachblip
					
					game.FadeScreenIn(500)
					
					bDraw20mmTrace = true
				end if
				
				if not bDeadEye then player.CanControlCharacter = false
				
				bInAC130 = true
				
				msg("Our AC130 is on air...", 2000)
			else
				player.CanControlCharacter = true
				
				bInAC130 = false
				
				if not bDeadEye then 
					game.FadeScreenOut(2500, true)
					
					player.character.detach
					player.character.freezeposition = true
					player.character.position = vecOriginalPos
					player.character.freezeposition = false
					player.character.visible = true
					player.character.makeproofto(false, false, false, false, false)
					native.function.call("SET_CHAR_COLLISION", player.character, true)
				end if
				
				plane.visible = false
				rocket.visible = false
				
				CamAC130.deactivate
				CamRocket.deactivate
				
				bNightVisionOn = false
				
				for each l as lights in lightList
					if exists(l) then
						if exists(l.light) then l.light.enabled = false
						if exists(l.light2) then l.light2.enabled = false
						if exists(l.light3) then l.light3.enabled = false
					end if
				next
				
				if not bDeadEye then game.FadeScreenIn(500)
				
				msg("AC130 did his job...", 2000)
			end if
		end if
		
		if bINAC130 andalso not bDeadEye then
			if e.key = (hkSpeedUp) then planeSpeedMultiplier += 0.1
			if e.key = (hkSpeedDown) then planeSpeedMultiplier -= 0.1
			
			if planeSpeedMultiplier > 2 then
				planeSpeedMultiplier = 2
			elseif planeSpeedMultiplier < 0.5 then
				planeSpeedMultiplier = 0.5
			end if
			
			if game.iskeypressed(hkSHoot) then
				player.character.WantedByPolice = true
				native.function.call("ALTER_WANTED_LEVEL_NO_DROP", player, 2)
				native.function.call("APPLY_WANTED_LEVEL_CHANGE_NOW", player, 2)
			end if
		end if
				
		if bINAC130 andalso bDeadEye andalso (e.key = keys.rbutton) then
			If Not Player.Character.Weapons.inSlot(WeaponSlot.Handgun).isPresent Then
                Native.Function.Call("GIVE_WEAPON_TO_CHAR", Player.Character, 4, 7, 1)
            End If
			
			if (player.character.weapons.current <> WeaponSlot.Handgun) then Player.Character.Weapons.inSlot(WeaponSlot.Handgun).Select
			
			camDEAim.deactivate
			
			camDEDir = game.currentcamera.direction
			
			camDEAimFOV = 50
			
			if not camDEAim.isactive then camDEAim.activate
			
			player.character.visible = false
		end if
		
		if not bDeadEye andalso (e.key = hkShoot) andalso bInAC130 andalso (currWeapon = 0) andalso not rocket.metadata.launched then
			fire105mm(true)
		end if
		
		if (e.key = hkNightvision) andalso bInAC130 andalso not rocket.metadata.launched then
			bNightVisionOn = not bNightVisionOn
			
			if not bNightVisionOn then	
				for each l as lights in lightList
					if exists(l) andalso exists(l.light) then
						l.light.enabled = false
					end if
				next
			end if
		end if
		
		if not bDeadEye andalso (e.key = hkCameraMode) andalso bInAC130 andalso not rocket.metadata.launched then
			camMode += 1
			
			if camMode > 2 then camMode = 0
			
			if camMode = 0 then
				msg("105mm Normal camera", 3000)
			elseif camMode = 1 then
				msg("105mm Camera on board", 3000)
			else
				msg("105mm Ground camera", 3000)
			end if
		end if
		
		if not bDeadEye andalso (e.key = hkChangeGun) andalso bInAC130 andalso not camRocket.isactive then
			currWeapon += 1
			
			if currWeapon > 2 then currWeapon = 0
		end if
		
		if not bDeadEye then
			if e.key = hkSwTo105mm then
				currWeapon = 0
			elseif e.key = hkSwTo40mm then
				currWeapon = 1
			elseif e.key = hkSwTo20mm then
				currWeapon = 2
			end if
		end if
    End Sub
	Private Sub keyUp(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyUp
		if bInAC130 andalso bDeadEye then
			if (e.key = keys.rbutton) then
				player.character.visible = true
				
				if camDEAim.isactive then					
					camDEAim.deactivate
				end if
			end if
		
			if (e.key = hkSwTo105mm) andalso not rocket.metadata.launched andalso DETarget.cpTarget.visible then
				currWeapon = 0
				
				if DETarget.valid then				
					DETarget.cpTarget.visible = false
					
					resetPlanePos
					
					fire105mm(true)
				end if
			end if
			
			if (e.key = hkSwTo40mm) andalso DETarget.cpTarget.visible then				
				currWeapon = 1
				
				DETarget.cpTarget.visible = false
				
				resetPlanePos
				
				DEShoots = 10
			end if
			
			if (e.key = hkSwTo20mm) andalso DETarget.cpTarget.visible then	
				currWeapon = 2
				
				DETarget.cpTarget.visible = false
				
				resetPlanePos
				
				DEShoots = 20				
			end if
		end if
	end sub
	
	private sub updatePlaneMov
		plane.position = plane.position - plane.direction * 1.5
		
		plane.heading = planeHeading
		
		planeHeading += 0.4
		
		if planeHeading > 360 then planeHeading = 0
		
		camAC130.position = plane.position
	end sub
	
	private sub resetPlanePos
		plane.position = player.character.position - game.currentcamera.direction * 5 + vector3.worldup * 250
		camAC130.position = plane.position
		plane.visible = true
	end sub
	
	private function targetedObj(pos as vector3, maxDist as double)
		'player.character.getboneposition(bone.head) + player.character.direction * 3
		dim vec as vector3 = pos
		dim vecGround as vector3
		dim deadPed as ped = nothing
		
		while vec.distanceto(player.character.position) < maxDist
			vec += game.currentcamera.direction / 2
			
			if vec.distanceto(player.character.position) < 3 then Continue while
			
			vecGround = world.getgroundposition(vec, Groundtype.highest)
			
			if vec.distanceto(vecGround) <= 0.5 then
				DETarget.reset
				DETarget.vec = vec
				DETarget.valid = true
				DETarget.cpTarget.visible = true
				return true
			end if
			
			for each v as vehicle in world.getvehicles(vec, 1.5)
				if exists(v) andalso (v <> player.character.currentvehicle) then
					DETarget.reset
					DETarget.v = v
					DETarget.bVeh = true
					DETarget.valid = true
					DETarget.cpTarget.visible = true
					return true
				end if
			next
			for each p as ped in world.getpeds(vec, 1.0)
				if exists(p) then
					if not p.isalive orelse (p.health <= 0) then
						deadPed = p
					else
						DETarget.reset
						DETarget.p = p
						DETarget.bPed = true
						DETarget.valid = true
						DETarget.cpTarget.visible = true
						return true
					end if
				end if
			next
		end while
		
		if exists(deadPed) then
			DETarget.reset
			DETarget.p = deadPed
			DETarget.bPed = true
			DETarget.valid = true
			DETarget.cpTarget.visible = true
			return true
		end if
		
		return false
	end function
	
	Private Sub general_tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick	
		if loadDelay > 0 then
			loadDelay -= me.interval
			
			if loadDelay <= 0 then loadAux
		end if
		
		timeScript += 10
		
		if timeScript > 3000 then timeScript = 0

		if bInAC130 then
			if bDeadEye then
				if game.isgamekeypressed(gamekey.aim) then
					DETargetUpdateVec
					
					if findTargetTime >= 200 then
						findTargetTime = 0
						
						if player.character.isalive andalso (DEShoots <= 0) andalso not rocket.metadata.launched then _
							targetedObj(player.character.getboneposition(bone.head), maxDistFindTargets)
					else
						findTargetTime += intervalFix
					end if
					
					if DETarget.valid then 
						if DETarget.bPed orelse (exists(DETarget.v) andalso DETarget.v.isonallwheels) then
							DETarget.cpTarget.position = DETarget.vec.toground
						else
							DETarget.cpTarget.position = DETarget.vec
						end if
						
						if DETarget.bPed then
							DETarget.cpTarget.diameter = 1
						else
							DETarget.cpTarget.diameter = 2
						end if
					else
						DETarget.cpTarget.visible = false
					end if
				elseif DETarget.cpTarget.visible then
					DETarget.cpTarget.visible = false
				end if
				
				if camDEAim.isactive then
					if not game.mouse.isButtonDown(System.Windows.Forms.MouseButtons.middle) then
						dim zBack as double = camDEDir.z						
						dim mouseMovAux as System.Drawing.PointF = game.mouse.movement
						
						mouseMovAux.x *= (camDEAimFOV / 50)
						mouseMovAux.y *= (camDEAimFOV / 50)
						
						'camDEDir = rotateVec(camDEDir, game.mouse.movement.x * -145)
						camDEDir = rotateVec(camDEDir, mouseMovAux.x * -145)
						'camDEDir.z = zBack - game.mouse.movement.y * 3
						camDEDir.z = zBack - mouseMovAux.y * 3
						
						camDEAim.position = player.character.getboneposition(bone.head) + player.character.direction / 2
						camDEAim.fov = camDEAimFOV
						camDEAim.direction = camDEDir
						
						if not exists(player.character.currentvehicle) then	player.character.heading = camDEAim.heading
					else
						camDEAimFOV += game.mouse.movement.y * 10
						
						if camDEAimFOV < 10 then
							camDEAimFOV = 10
						elseif camDEAimFOV > 50 then
							camDEAimFOV = 50
						end if
						
						camDEAim.FOV = camDEAimFOV
					end if
				end if
				
				if DEShoots > 0 then
					DETargetUpdateVec
					
					if DETarget.valid then 
						if (currWeapon = 1) andalso (timeShoot40mm <= 0) then
							DEShoots -= 1
							fire40mm(true)
						elseif (currWeapon = 2) andalso (timeShoot20mm <= 0) then
							DEShoots -= 1
							fire20mm(true)							
						end if
					end if
				end if
			end if
			
			if camDelay > 0 then
				camDelay -= 10

				if camDelay <= 0 then bCancelLights = false
			end if
			
			if (camRocket.isactive) then
				if (camRocket.direction.z < 0) then
					if not bDeadEye then plane.visible = false
				end if
				
				if (camDelay <= 0) then
					if not bDeadEye then plane.visible = false
					
					camRocket.deactivate
					
					if not bDeadEye then camAC130.activate
				end if
			end if
			
			if exists(plane) then
				fire105mm
				
				fire40mm
				
				fire20mm
				
				if not bDeadEye then
					if(timeScript mod 300 = 0) then				
						'playerPosAux = getGroundPos(plane.position + camAC130.direction * 200, camAC130.direction)
						playerPosAux = getGroundPos(camAC130.position, camAC130.direction, groundtype.lowest) + vector3.worldup * 10
						
						if playerPosAux.distanceto(player.character.position) > 25 then
							player.character.freezeposition = true
							player.character.freezeposition = false
							player.character.position = playerPosAux
							player.character.heading = camAC130.heading
						end if
					end if
				
					player.character.velocity = playerPosAux - player.character.position
					
					if bNightVisionOn then
						NVFindObjects
						
						NVGlowObjects
					end if				
				
					if game.iskeypressed(keys.a) then
						planeHeading += 1.1
					elseif game.iskeypressed(keys.d) then
						planeHeading -= 1.1
					end if
					
					if planeHeading > 360 then planeHeading = 0
					
					plane.heading = planeHeading
					
					if currWeapon = 0 then
						plane.position = plane.position - plane.direction * 0.4	* planeSpeedMultiplier
					elseif currWeapon = 1 then
						plane.position = plane.position - plane.direction * 0.3	* planeSpeedMultiplier		
					else
						plane.position = plane.position - plane.direction * 0.2	* planeSpeedMultiplier		
					end if
					
					if not camAC130.isactive then camAC130.activate
					
					dim mouseMovAux as System.Drawing.PointF = game.mouse.movement
					
					'mouseMovAux.x *= (camFOV / 50)
					'mouseMovAux.y *= (camFOV / 50)
					
					if currWeapon = 0 then
						'camAC130.position = plane.position + camDirOrig * 60 'camAC130.direction * 150
						camAC130.position = plane.position + camAC130.direction * 150
					elseif currWeapon = 1 then
						'camAC130.position = plane.position + camDirOrig * 80 'camAC130.direction * 220
						camAC130.position = plane.position + camAC130.direction * 220
						mouseMovAux.x /= 2
						mouseMovAux.y /= 2.5
					else if currWeapon = 2 then
						'camAC130.position = plane.position + camDirOrig * 110 'camAC130.direction * 250
						'camAC130.position = plane.position + camAC130.direction * 250
						
						camHeightAux = math.round(camDir.z * 7)
						
						if (camHeight <> camHeightAux) andalso (camHeight < camHeightAux) then
							camHeight += 1
						elseif (camHeight <> camHeightAux) andalso (camHeight > camHeightAux) then
							camHeight -= 1
						end if
						
						camAC130.position = plane.position + camAC130.direction * (250 + camHeight)
						
						mouseMovAux.x /= 4
						mouseMovAux.y /= 5						
					end if
					
					if not game.mouse.isButtonDown(System.Windows.Forms.MouseButtons.middle) then
						dim camDirAux as vector3 = rotatevec(camDir, mouseMovAux.x * -20)
						
						camDir = camDirAux
						
						if camDir.z > -1 then
							camDir.z -= mouseMovAux.y / 2
						else
							camDir.z -= mouseMovAux.y
						end if
						
						if (currWeapon = 2) andalso (camDir.z < -3.5) then
							camDir.z = -3.5
						elseif camDir.z < -4 then
							camDir.z = -4
						elseif camDir.z > 0 then
							camDir.z = 0
						end if
						
						camAC130.direction = camDir
					else
						camFOV += game.mouse.movement.y * 10
						
						if camFOV < 1 then
							camFOV = 1
						elseif camFOV > 100 then
							camFOV = 100
						end if
						
						camAC130.FOV = camFOV
					end if
					
					if shakeCam > 0 then
						camAC130.position = camAC130.position.around(shakeCamAmount)
						
						shakeCam -= 1
					end if
				else
					updatePlaneMov
				end if
			end if
		end if
	end sub		
	
	private sub Fire20mm(optional bDeadEyeShoot as boolean = false)
		if timeShoot20mm <= 0 then	
			if (bDeadEyeShoot orelse game.iskeypressed(hkShoot) orelse (DEShoots > 0)) andalso (currWeapon = 2) then
				timeShoot20mm = 20
				
				dim iniPos, finPos as vector3
				'dim effect as int32 = 0
				
				if not bDeadEye then
					iniPos = game.currentcamera.position + game.currentcamera.direction * 10
				else
					iniPos = DETarget.vec + vector3.worldup * 50
				end if
				
				'effect = Native.Function.Call(Of int32)("start_PTFX", "wpn_bullet_trace", iniPos.x, iniPos.y, iniPos.z, -10.0, -45.0, 0, 3.0)
				'Native.Function.Call("trigger_PTFX", "wpn_bullet_trace", iniPos.x, iniPos.y, iniPos.z, -10.0, -45.0, 0, 3.0)
				
				if not bDeadEye then
					bDraw20mmTrace = true
					
					playSound(".\scripts\AC130Files\20mm.wav")
					
					iniPos = game.currentcamera.position
					finPos = game.currentcamera.position.around(2) + game.currentcamera.direction * 300
					native.function.call("FIRE_SINGLE_BULLET", iniPos.x, iniPos.y, iniPos.z, finPos.x, finPos.y, finPos.z, 1000)
					finPos = game.currentcamera.position.around(1) + game.currentcamera.direction * 300
					native.function.call("FIRE_SINGLE_BULLET", iniPos.x, iniPos.y, iniPos.z, finPos.x, finPos.y, finPos.z, 1000)
					finPos = game.currentcamera.position.around(1) + game.currentcamera.direction * 300
					native.function.call("FIRE_SINGLE_BULLET", iniPos.x, iniPos.y, iniPos.z, finPos.x, finPos.y, finPos.z, 1000)
				else
					playSound(".\scripts\AC130Files\20mm2.wav")
					
					if DETarget.bPed then finPos = DETarget.vec.toground.around(0.5) else finPos = DETarget.vec.toground.around(1.5)
					native.function.call("FIRE_SINGLE_BULLET", iniPos.x, iniPos.y, iniPos.z, finPos.x, finPos.y, finPos.z, 1000)
					if DETarget.bPed then finPos = DETarget.vec.toground.around(0.5) else finPos = DETarget.vec.toground.around(1.5)
					native.function.call("FIRE_SINGLE_BULLET", iniPos.x, iniPos.y, iniPos.z, finPos.x, finPos.y, finPos.z, 1000)
					if DETarget.bPed then finPos = DETarget.vec.toground.around(0.5) else finPos = DETarget.vec.toground.around(1.5)
					native.function.call("FIRE_SINGLE_BULLET", iniPos.x, iniPos.y, iniPos.z, finPos.x, finPos.y, finPos.z, 1000)
				end if
				
				'native.function.call("stop_ptfx", effect)
				
				if dot20mmTimeScarePeds <= 0 then
					dot20mmTimeScarePeds = 50
					
					dim vecAux as vector3
						
					if not bDeadEye then
						vecAux = getGroundPos(iniPos, game.currentcamera.direction)
					else
						vecAux = DETarget.vec
					end if
					
					for each p as ped in world.getpeds(vecAux, 7.0)
						if exists(p) andalso (p <> player.character) andalso not p.metadata.flee then
							p.task.FleeFromChar(player.character, false)
							p.metadata.flee = true
						end if
					next
				else
					dot20mmTimeScarePeds -= intervalFix
				end if				
				
				dim doorTmp as int16 = 0
				
				for each v as vehicle in world.getvehicles(finPos, 2)
					if exists(v) then 
						v.applyforce(vector3.worlddown / 4)			
						
						doorTmp = random(0, 5)
						
						native.function.call("break_car_door", v, doorTmp, false)
					end if
				next
					
				shakeCam = 1
				shakeCamAmount = 0.1
			end if
		else
			timeShoot20mm -= intervalFix
		end if
	end sub
	
	private sub fire40mm(optional bShoot as boolean = false)
		if timeShoot40mm > 0 then timeShoot40mm -= intervalFix

		if (currWeapon = 1) andalso ((game.iskeypressed(hkShoot) andalso camAC130.isactive) orelse bShoot)  then
			if timeShoot40mm <= 0 then				
				timeShoot40mm = 50
				
				if exists(dot40mmList.item(dot40mmBullet).bullet) then
					if not dot40mmList.item(dot40mmBullet).launched then
						dot40mmList.item(dot40mmBullet).launched = true								
						dot40mmList.item(dot40mmBullet).bullet.detach
						
						if not bDeadEye then
							dot40mmList.item(dot40mmBullet).bullet.position = camAc130.position
							dot40mmList.item(dot40mmBullet).dir = camAC130.direction * 100
						else
							dot40mmList.item(dot40mmBullet).bullet.position = DETarget.vec + vector3.worldup * 50
						end if
						
						dot40mmList.item(dot40mmBullet).bullet.visible = true
						
						native.function.call("SET_OBJECT_RECORDS_COLLISIONS", dot40mmList.item(dot40mmBullet).bullet, 1)
						
						if not bDeadEye then
							playSound(".\scripts\AC130Files\40mm.wav")	
						else
							playSound(".\scripts\AC130Files\40mm2.wav")	
						end if
						
						shakeCam = 2
						shakeCamAmount = 0.3
					end if
				end if
					
				dot40mmBullet += 1
				
				if dot40mmBullet > dot40mmList.count - 1 then dot40mmBullet = 0
			end if
		end if
		
		for each b as dot40mm in dot40mmList
			if exists(b.bullet) then
				if b.launched then
					if ((b.bullet.position.distanceto(plane.position) > 20) andalso native.function.call(of boolean)("HAS_OBJECT_COLLIDED_WITH_ANYTHING", b.bullet)) _
					   orelse (b.timeOut >= 1000) then						
						b.timeOut = 0
						b.launched = false
						
						if not bDeadEye then
							native.function.call("trigger_PTFX", "exp_grenade", b.bullet.position.x, b.bullet.position.y, b.bullet.position.z, 0, 0, 0, 0.5)
						else
							native.function.call("trigger_PTFX", "exp_grenade", b.bullet.position.x, b.bullet.position.y, b.bullet.position.z, 0, 0, 0, 0.2)
						end if
						
						dim vL as vehicle()
						vl = world.getvehicles(b.bullet.position, 6.0)
						
						for each v as vehicle in vL
							if exists(v) then native.function.call("SET_VEHICLE_EXPLODES_ON_HIGH_EXPLOSION_DAMAGE", v, 0)
						next
						
						if bDeadEye then
							world.addexplosion(b.bullet.position, explosiontype.rocket, 0.5, true, true, 0.05)
						else
							world.addexplosion(b.bullet.position, explosiontype.rocket, 0.5, false, true, 0.05)
						end if
						
						native.function.call("SET_OBJECT_RECORDS_COLLISIONS", b.bullet, 0)
						
						native.function.call("ATTACH_OBJECT_TO_OBJECT", b.bullet, plane, false, 0, 0, 0, 0, 0, 0)
						
						b.bullet.visible = false
						
						for each v as vehicle in vL
							if exists(v) then v.petroltankhealth = 1000
						next
					else
						if not bDeadEye then
							b.bullet.applyforce(b.dir)
						else
							b.bullet.applyforce((DETarget.vec.around(2) - b.bullet.position))
						end if
						
						b.timeOut += intervalFix
					end if
				end if
			else
				dim tmp40mm as dot40mm
		
				tmp40mm = new dot40mm(player.character.position + vector3.worldup * 2, plane)
			
				dot40mmList.add(tmp40mm)
			end if
		next	
	end sub
	
	private sub fire105mm(optional bSet as boolean = false)
		if bSet then
			if not bDeadEye then
				shakeCam = 5
				shakeCamAmount = 1.5
			end if
			
			RocketExpTimeout = 2000
			RocketDelay = 150
			Rocket.metadata.launched = true
			
			if camMode = 1 then					
				camRocket.direction = camAC130.direction
				camRocket.position = camAC130.position '- camAC130.direction * 2
				camRocket.lookAt(camRocket.position + camRocket.direction * 300)					
			elseif camMode = 2 then
				'camRocket.position = (world.GetNextPositionOnStreet(getGroundPos(camAC130.position, camAC130.direction)) + vector3.worldup * 35)					
				camRocket.position = (getGroundPos(camAC130.position, camAC130.direction) + vector3.worldup * 35).around(5)			
				camDelay = 1500
			end if
			
			if rocketEffect <> 0 then native.function.call("stop_ptfx", rocketEffect)
			
			rocketEffect = native.function.call(of int32)("START_PTFX_ON_OBJ", "weap_rocket_player", rocket, 0, 0, 0, 0, 0, 0, 0.5)
			
			native.function.call("SET_OBJECT_RECORDS_COLLISIONS", rocket, 1)
			
			'rocketRotation = game.currentcamera.direction				
			rocketRotation = camAC130.direction				
			
			if (camMode = 1) orelse (camMode = 2) then
				timeScript = 490
				bCancelLights = true
			end if
			
			if not bDeadEye then
				playSound(".\scripts\AC130Files\105mm.wav")	
			else
				playSound(".\scripts\AC130Files\105mm2.wav")	
			end if
			
			rocket.visible = true
			
			exit sub
		end if
		
		if rocket.metadata.launched then	
			if RocketDelay <= 0 then
				if camMode = 1 then
					camRocket.position = rocket.position
					
					if not CamRocket.isactive then camRocket.activate
				elseif camMode = 2 then
					camRocket.LookAt(rocket.position)
					
					if not CamRocket.isactive then 
						camRocket.activate
						plane.visible = true
					end if
				end if
				
				RocketExpTimeout -= 10
				
				if ((rocket.position.distanceto(plane.position) > 20) andalso native.function.call(of boolean)("HAS_OBJECT_COLLIDED_WITH_ANYTHING", rocket)) orelse (RocketExpTimeout <= 0) then					
					native.function.call("SET_OBJECT_RECORDS_COLLISIONS", rocket, 0)
					
					dim rocketPos as vector3 = rocket.position
					dim effectPos as vector3 = rocketPos.around(10)
					native.function.call("trigger_PTFX", "exp_ship_destroy", rocketPos.x, rocketPos.y, rocketPos.z, 0, 0, 0, 1.0)
					native.function.call("trigger_PTFX", "exp_ship_destroy", effectPos.x, effectPos.y, rocketPos.z, 0, 0, 0, 1.0)
					effectPos = rocketPos.around(10)
					native.function.call("trigger_PTFX", "exp_ship_destroy", effectPos.x, effectPos.y, rocketPos.z, 0, 0, 0, 1.0)
					world.addexplosion(rocketPos, explosiontype.rocket, 100.0, true, true, 1.0)
					world.addexplosion(rocketPos.around(10), explosiontype.rocket, 100.0, true, true, 1.0)
					world.addexplosion(rocketPos.around(10), explosiontype.rocket, 100.0, true, true, 1.0)

					for each v as vehicle in world.getvehicles(rocketPos, 30.0)
						if exists(v) andalso (math.abs(v.position.z - rocketPos.z) < 3) then
							if not v.model.istrain then
								native.function.call("detach_car", v)
								v.freezeposition = false
								v.applyforce(((v.position - rocketPos) + vector3.worldup * 3) / (v.position.distanceto(rocketPos) / 6), vector3.worldup * 4)

								if v.position.distanceto(rocketPos) <= 20 then v.petroltankhealth = -1
							else
								trainItem = new trains(v)
								trainList.add(trainItem)
								v.delete
							end if
						end if
					next	
					for each p as ped in world.getpeds(rocketPos, 30.0)
						if exists(p) then
							if bDeadEye andalso (p.position.distanceto(rocketPos) <= 20) then p.health = math.round(p.health / 2)
							
							p.preventragdoll = false
							p.euphoria.bodybalance.start(5000)
							p.applyforce(((p.position - rocketPos) + vector3.worldup * 2) / (p.position.distanceto(rocketPos) / 10))
						end if
					next

					dim fakeTrain as gta.object = nothing
					
					for each t as trains in trainList
						if t.bCreate then
							fakeTrain = world.createobject(t.m, t.pos)
							
							if exists(fakeTrain) then
								t.train = fakeTrain
								t.train.rotation = t.rot
							end if
						end if
					next
					for each t as trains in trainList						
						if exists(t.train) then
							if t.bCreate then
								world.addexplosion(t.train.position, explosiontype.rocket, 1.0)
								wait(100)
								t.train.applyforce(((t.train.position - rocketPos) + vector3.worldup * 8) / (t.train.position.distanceto(rocketPos) / 6), vector3.worldup * 4)
							elseif t.train.position.distanceto(rocketPos) < 30 then
								t.train.applyforce(((t.train.position - rocketPos) + vector3.worldup * 8) / (t.train.position.distanceto(rocketPos) / 6), vector3.worldup * 4)
							end if
						end if
						
						t.bCreate = false
					next
					
					native.function.call("ATTACH_OBJECT_TO_OBJECT", rocket, plane, false, 0, -10.0, 0, 0, 0, 0)
					
					rocket.metadata.launched = false
					
					if camMode = 1 then
						camRocket.deactivate
						
						if not bDeadEye then camAC130.activate
					end if
					
					if camMode <> 2 then bCancelLights = false
					
					rocket.visible = false
				else
					'Rocket.velocity = rocketRotation * 250
					if not bDeadEye then
						rocket.applyforce(rocketRotation * 100)
					else
						rocket.applyforce((DETarget.vec - rocket.position))
					end if
				end if
			else			
				RocketDelay -= 10
				
				if RocketDelay <= 0 then
					Rocket.detach
					Rocket.position = camac130.position - camac130.direction * 3
					rocket.applyforce(rocketRotation)
				end if
			end if
		end if
	end sub
	
	private sub NVFindObjects
		timeNVFindObjCount += intervalFix
		
		if timeNVFindObjCount >= timeNVFindObj then
			timeNVFindObjCount = 0
			
			for each l as lights in lightList
				if exists(l) then
					if exists(l.light) then l.light.disable								
					if exists(l.light2) then l.light2.disable								
					if exists(l.light3) then l.light3.disable								
				end if
			next
			
			lightList.clear
			
			if not bCancelLights then
				for each v as vehicle in world.getallvehicles
					if exists(v) andalso (v.health > 0) then
						lightTmp = new lights
						lightTmp.veh = v
						lightTmp.vehH = v.model.getdimensions.z
						lightTmp.light = new light
						
						if v.model.getdimensions.y > 9 then
							lightTmp.light2 = new light
							lightTmp.light3 = new light
							
							'lightTmp.l2pos = 6
							'lightTmp.l3pos = -6				
							lightTmp.l2pos = v.model.getdimensions.y / 3				
							lightTmp.l3pos = v.model.getdimensions.y / -3			
						elseif v.model.getdimensions.y > 6 then 
							lightTmp.light2 = new light
							
							'lightTmp.l1pos = 2
							'lightTmp.l2pos = -2
							lightTmp.l1pos = v.model.getdimensions.y / 2
							lightTmp.l2pos = v.model.getdimensions.y / -2
						end if
						
						
						lightTmp.light.enabled = true
						lightTmp.light.intensity = 1000.0
						lightTmp.light.range = 3.5
						lightTmp.light.color = system.drawing.color.green	

						if exists(lightTmp.light2) then
							lightTmp.light2.enabled = true
							lightTmp.light2.intensity = 1000.0
							lightTmp.light2.range = 4.0
							lightTmp.light.range = 4.0
							lightTmp.light2.color = system.drawing.color.green
						end if
						if exists(lightTmp.light3) then
							lightTmp.light3.enabled = true
							lightTmp.light3.intensity = 1000.0
							lightTmp.light3.range = 5.0
							lightTmp.light2.range = 5.0
							lightTmp.light.range = 5.0
							lightTmp.light3.color = system.drawing.color.green
						end if
						
						lightList.add(lightTmp)
					end if
				next
				for each p as ped in world.getallpeds
					if exists(p) andalso (p <> player.character) andalso not p.issittinginvehicle andalso p.isalive then
						lightTmp = new lights
						lightTmp.anPed = p
						lightTmp.light = new light
						lightTmp.light.enabled = true
						lightTmp.light.intensity = 1000.0
						lightTmp.light.range = 2.25
						lightTmp.light.color = system.drawing.color.green
						lightTmp.bVeh = false
						lightList.add(lightTmp)
					end if
				next
			end if
		end if
	end sub
	
	private sub NVGlowObjects
		timeNVGlowObjCount += intervalFix
		
		if timeNVGlowObjCount >= timeNVGlowObj then
			timeNVGlowObjCount = 0
			
			if not bCancelLights then
				for each l as lights in lightList
					if exists(l) then
							if l.bVeh then
								if exists(l.light) then
									if not exists(l.veh) then
										l.light.enabled = false
									else
										l.light.position = l.veh.position + l.veh.direction * l.l1pos + vector3.worldup * l.vehH
									end if									
								end if
								if exists(l.light2) then
									if not exists(l.veh) then
										l.light2.enabled = false
									else
										l.light2.position = l.veh.position + l.veh.direction * l.l2pos + vector3.worldup * l.vehH
									end if									
								end if
								if exists(l.light3) then
									if not exists(l.veh) then
										l.light3.enabled = false
									else
										l.light3.position = l.veh.position + l.veh.direction * l.l3pos + vector3.worldup * l.vehH
									end if									
								end if
							else
								if exists(l.light) then
									if not exists(l.anPed) then
										l.light.enabled = false
									else
										l.light.position = l.anPed.position + vector3.worldup / 3
									end if
								end if
							end if				
					end if
				next
			end if
		end if
	end sub
	
	private function getGroundPos(pos as vector3, dir as vector3, optional pGroundType as groundtype = groundtype.highest)
		dim vecRes as vector3 = world.getgroundposition(pos, pGroundType)
		dim dist as double
		dim minDist as double = 100000
		
		while (vecRes.distanceto(pos) > 1)			
			pos += dir / 2
			
			vecRes = world.getgroundposition(pos, pGroundtype)
			
			dist = vecRes.distanceto(pos)
			
			if dist < minDist then
				minDist = dist
			else				
				exit while				
			end if
		end while
		
		return vecRes
	end function
	
	Private Sub GraphicsEventHandler(ByVal sender As Object, ByVal e As GTA.GraphicsEventArgs) Handles mybase.PerFrameDrawing		
		try
			bErroDraw = false
			
			if bInAC130 then
				if not bDeadEye then
					if not bDisableTextures then
						if currWeapon = 0 then
							if (camMode = 0) or ((camMode <> 0) and not rocket.metadata.launched and (camDelay <= 0)) then
								if bCrosshair then e.graphics.drawsprite(texCr105, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)
							end if
						elseif currWeapon = 1 then
							if bCrosshair then e.graphics.drawsprite(texCr40, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)
						else
							if bCrosshair then e.graphics.drawsprite(texCr20, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)
						end if
					end if
					
					if not bDisableTextures andalso bDraw20mmTrace then
						e.graphics.drawsprite(text20mmTrace, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)
						
						bDraw20mmTrace = false
					end if
					
					if bCancelLights then exit sub
					
					e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 2, 5, 5, Color.FromArgb(150, 255, 0, 0))
					
					if bNightVisionOn then
						e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, Color.FromArgb(80, 0, 255, 0))
					end if
					
					if not bDisableTextures andalso bNoiseFX then
						if noiseEffectCounter < 2 then
							e.graphics.drawsprite(textN1, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)
						elseif noiseEffectCounter < 4 then					
							e.graphics.drawsprite(textN2, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)	
						elseif noiseEffectCounter < 6 then					
							e.graphics.drawsprite(textN3, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)	
						elseif noiseEffectCounter < 8 then					
							e.graphics.drawsprite(textN4, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)	
						else
							noiseEffectCounter = 0
							e.graphics.drawsprite(textN1, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)
						end if
						
						noiseEffectCounter += 1
					end if
				else
					if game.isgamekeypressed(gamekey.aim) then
						if not bDisableTextures andalso player.character.isalive then e.graphics.drawsprite(textDEAim, game.resolution.width / 2, game.resolution.height / 2, game.resolution.width, game.resolution.height, 0)
					end if
				end if
			end if
		catch
			bErroDraw = true
		end try
				
		if bINAC130 andalso (bDisableTextures orelse bErroDraw orelse not bCrosshair orelse (bDeadEye andalso game.iskeypressed(keys.rbutton))) then
			if (not bDeadEye orelse (bDeadEye andalso game.iskeypressed(keys.rbutton))) then _
				e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 2, 5, 5, Color.FromArgb(150, 255, 0, 0))
			
			if (not bDeadEye andalso (currWeapon = 0) orelse (bDeadEye andalso game.iskeypressed(keys.rbutton))) then				
				e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 2.5, 300, 2, Color.FromArgb(100, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 1.67, 300, 2, Color.FromArgb(100, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 1.699, game.resolution.height / 2, 2, 200, Color.FromArgb(100, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 2.44, game.resolution.height / 2, 2, 200, Color.FromArgb(100, 255, 255, 255))				
				e.Graphics.DrawRectangle(game.resolution.width / 2.64, game.resolution.height / 2, 100, 2, Color.FromArgb(100, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 1.615, game.resolution.height / 2, 100, 2, Color.FromArgb(100, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 2.85, 2, 100, Color.FromArgb(100, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 1.541, 2, 100, Color.FromArgb(100, 255, 255, 255))
			elseif not bDeadEye andalso (currWeapon = 1) then				
				e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 2, 400, 2, Color.FromArgb(75, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 2, 2, 250, Color.FromArgb(75, 255, 255, 255))
			elseif not bDeadEye andalso (currWeapon = 2) then				
				e.Graphics.DrawRectangle(game.resolution.width / 2.35, game.resolution.height / 2, 200, 2, Color.FromArgb(75, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 1.74, game.resolution.height / 2, 200, 2, Color.FromArgb(75, 255, 255, 255))
				e.Graphics.DrawRectangle(game.resolution.width / 2, game.resolution.height / 1.73, 2, 125, Color.FromArgb(75, 255, 255, 255))
			end if
			
			if (currWeapon = 0) then
				e.graphics.drawtext(hkSwTo105mm.tostring & " - 105mm", 15, game.resolution.height / 1.4)
				e.graphics.drawtext(hkSwTo40mm.tostring & " - 40mm", 15, game.resolution.height / 1.45, System.Drawing.Color.gray)
				e.graphics.drawtext(hkSwTo20mm.tostring & " - 20mm", 15, game.resolution.height / 1.5, System.Drawing.Color.gray)
			elseif (currWeapon = 1) then
				e.graphics.drawtext(hkSwTo105mm.tostring & " - 105mm", 15, game.resolution.height / 1.4, System.Drawing.Color.gray)
				e.graphics.drawtext(hkSwTo40mm.tostring & " - 40mm", 15, game.resolution.height / 1.45)
				e.graphics.drawtext(hkSwTo20mm.tostring & " - 20mm", 15, game.resolution.height / 1.5, System.Drawing.Color.gray)
			elseif (currWeapon = 2) then
				e.graphics.drawtext(hkSwTo105mm.tostring & " - 105mm", 15, game.resolution.height / 1.4, System.Drawing.Color.gray)
				e.graphics.drawtext(hkSwTo40mm.tostring & " - 40mm", 15, game.resolution.height / 1.45, System.Drawing.Color.gray)
				e.graphics.drawtext(hkSwTo20mm.tostring & " - 20mm", 15, game.resolution.height / 1.5)
			end if
			
			if bDeadEye andalso DETarget.cpTarget.visible then _
				e.graphics.drawtext("Locked", 15, game.resolution.height / 1.3)
		end if
	end sub
	
	private function intervalFix
		return (me.interval * (25 / game.fps))
	end function
	
	Private Sub PlaySound(sFile as string)
        Try
			Dim Sound As New System.Media.SoundPlayer()

			Sound.SoundLocation = sFile
			Sound.Load()
			Sound.Play()
        Catch
        End Try
    End Sub

	function rotateVec(vec as vector3, angle as double)
		angle = angle * (3.1415 / 180)
		
		dim s as double = system.math.sin(angle)
		dim c as double = system.math.cos(angle)
		
		vec.x = vec.x * c - vec.y * s
		vec.y = vec.x * s + vec.y * c
		
		return vec
	end function
	
	Private Function random(ByVal min As int32, ByVal max As int32)
        Dim rnd As random = New random(System.DateTime.Now.Millisecond)
        random = rnd.next(min, max)
    End Function
End Class